#!/bin/bash -ex

until docker exec mysql1 sh -c 'export MYSQL_PWD=mysql1; mysql -u root -e ";"'
do
    echo "Waiting for mysql1 database connection..."
    sleep 4
done

priv_stmt='CREATE USER "mydb_slave_user"@"%" IDENTIFIED BY "mydb_slave_pwd"; GRANT REPLICATION SLAVE ON *.* TO "mydb_slave_user"@"%"; FLUSH PRIVILEGES;'
docker exec mysql1 sh -c "export MYSQL_PWD=mysql1; mysql -u root -e '$priv_stmt'"

until docker-compose exec mysql2 sh -c 'export MYSQL_PWD=mysql2; mysql -u root -e ";"'
do
    echo "Waiting for mysql2 database connection..."
    sleep 4
done

MS_STATUS=`docker exec mysql1 sh -c 'export MYSQL_PWD=mysql1; mysql -u root -e "SHOW MASTER STATUS"'`
CURRENT_LOG=`echo $MS_STATUS | awk '{print $6}'`
CURRENT_POS=`echo $MS_STATUS | awk '{print $7}'`

start_slave_stmt="CHANGE MASTER TO MASTER_HOST='mysql1',MASTER_PORT=3307,MASTER_USER='mydb_slave_user',MASTER_PASSWORD='mydb_slave_pwd',MASTER_LOG_FILE='$CURRENT_LOG',MASTER_LOG_POS=$CURRENT_POS; START SLAVE;"
start_slave_cmd='export MYSQL_PWD=mysql2; mysql -u root -e "'
start_slave_cmd+="$start_slave_stmt"
start_slave_cmd+='"'
docker exec mysql2 sh -c "$start_slave_cmd"

docker exec mysql2 sh -c "export MYSQL_PWD=mysql2; mysql -u root -e 'SHOW SLAVE STATUS \G'"
